using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace BDSortIssue
{
    partial class ProductBO
    {

        #region Component Implementation

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            components = new System.ComponentModel.Container();

            this.CheckRulesOnCurrentRow += new CheckRulesOnCurrentRowEventHandler(ProductBO_CheckRulesOnCurrentRow);
            this.SetDefaultValues += new SetDefaultValuesEventHandler(ProductBO_SetDefaultValues);
        }

        #endregion


        #region BusinessLayer Overriden Methods & Properties

        /// <summary>
        /// The collection of required fields for the business object.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override RequiredFieldsCollection RequiredFields
        {
            get
            {
                return base.RequiredFields;
            }
            set
            {
                base.RequiredFields = value;
            }
        }

        /// <summary>
        /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override IBusinessParentRelationship ParentRelationship
        {
            get
            {
                return base.ParentRelationship;
            }
            set
            {
                base.ParentRelationship = value;
            }
        }

        /// <summary>
        /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
        /// </summary>
        protected override String AllFieldNames
        {
            get
            {
                return "[ProductID],[Name],[ProductNumber],[MakeFlag],[FinishedGoodsFlag],[Color],[SafetyStockLevel],[ReorderPoint],[StandardCost],[ListPrice],[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode],[Weight],[DaysToManufacture],[ProductLine],[Class],[Style],[ProductSubcategoryID],[ProductModelID],[SellStartDate],[SellEndDate],[DiscontinuedDate],[rowguid],[ModifiedDate]";
            }
        }

        /// <summary>
        /// The name of the database that contains the table to which this business object is mapped.
        /// </summary>
        public override String Database
        {
            get
            {
                return "AdventureWorks";
            }
        }

        private static string[] _PrimaryKeyFields = new string[] { "ProductID" };
        /// <summary>
        /// Gets the field or fields that comprise the primary key for the business object.
        /// </summary>
        public override string[] PrimaryKeyFields
        {
            get
            {
                return _PrimaryKeyFields;
            }
        }

        /// <summary>
        /// The name of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableName
        {
            get
            {
                return "Product";
            }
        }

        /// <summary>
        /// The schema of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableSchema
        {
            get
            {
                return "Production";
            }
        }

        /// <summary>
        /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
        /// </summary>
        protected override DataColumn[] CreateTableSchema()
        {
            return new DataColumn[] {
new DataColumn("ProductID", typeof(System.Int32)),
new DataColumn("Name", typeof(System.String)),
new DataColumn("ProductNumber", typeof(System.String)),
new DataColumn("MakeFlag", typeof(System.Boolean)),
new DataColumn("FinishedGoodsFlag", typeof(System.Boolean)),
new DataColumn("Color", typeof(System.String)),
new DataColumn("SafetyStockLevel", typeof(System.Int16)),
new DataColumn("ReorderPoint", typeof(System.Int16)),
new DataColumn("StandardCost", typeof(System.Decimal)),
new DataColumn("ListPrice", typeof(System.Decimal)),
new DataColumn("Size", typeof(System.String)),
new DataColumn("SizeUnitMeasureCode", typeof(System.String)),
new DataColumn("WeightUnitMeasureCode", typeof(System.String)),
new DataColumn("Weight", typeof(System.Decimal)),
new DataColumn("DaysToManufacture", typeof(System.Int32)),
new DataColumn("ProductLine", typeof(System.String)),
new DataColumn("Class", typeof(System.String)),
new DataColumn("Style", typeof(System.String)),
new DataColumn("ProductSubcategoryID", typeof(System.Int32)),
new DataColumn("ProductModelID", typeof(System.Int32)),
new DataColumn("SellStartDate", typeof(System.DateTime)),
new DataColumn("SellEndDate", typeof(System.DateTime)),
new DataColumn("DiscontinuedDate", typeof(System.DateTime)),
new DataColumn("rowguid", typeof(System.Guid)),
new DataColumn("ModifiedDate", typeof(System.DateTime))};
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected void AddBrokenRule(ProductBOFieldNames Field, string ErrorMessage)
        {
            base.AddBrokenRule(Field, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected new void AddBrokenRule(string FieldName, string ErrorMessage)
        {
            base.AddBrokenRule(FieldName, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected void AddBrokenRuleByKey(ProductBOFieldNames Field, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(Field, ErrorMessageKey);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected new void AddBrokenRuleByKey(string FieldName, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(FieldName, ErrorMessageKey);
        }

        /// <summary>
        /// Gets a collection of the names for all fields that belong to this business object and map to the database.
        /// </summary>
        public override List<string> AllFieldsList
        {
            get
            {
                return _AllFieldsList;
            }
        }

        /// <summary>
        /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
        /// </summary>
        public override Dictionary<string, DbType> FieldDbTypes
        {
            get
            {
                return _FieldDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
        /// </summary>
        public override BusinessLayerFieldEnumDictionary FieldEnums
        {
            get
            {
                return _FieldEnums;
            }
        }

        /// <summary>
        /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldLengths
        {
            get
            {
                return _FieldLengths;
            }
        }

        /// <summary>
        /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldNativeDbTypes
        {
            get
            {
                return _FieldNativeDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of the security permission keys for each field in the business object.
        /// </summary>
        public override Dictionary<string, string> FieldPermissionKeys
        {
            get
            {
                return _FieldPermissionKeys;
            }
        }

        #endregion

        #region Field Properties

        /// <summary>
        /// ProductID
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ProductID"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 ProductID
        {
            get
            {
                return (System.Int32)this.CurrentRow["ProductID"];
            }
            set
            {
                this.CurrentRow["ProductID"] = value;
            }
        }

        /// <summary>
        /// Name
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Name"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Name
        {
            get
            {
                return (System.String)this.CurrentRow["Name"];
            }
            set
            {
                this.CurrentRow["Name"] = value;
            }
        }

        /// <summary>
        /// ProductNumber
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ProductNumber"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String ProductNumber
        {
            get
            {
                return (System.String)this.CurrentRow["ProductNumber"];
            }
            set
            {
                this.CurrentRow["ProductNumber"] = value;
            }
        }

        /// <summary>
        /// MakeFlag
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("MakeFlag"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Boolean MakeFlag
        {
            get
            {
                return (System.Boolean)this.CurrentRow["MakeFlag"];
            }
            set
            {
                this.CurrentRow["MakeFlag"] = value;
            }
        }

        /// <summary>
        /// FinishedGoodsFlag
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("FinishedGoodsFlag"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Boolean FinishedGoodsFlag
        {
            get
            {
                return (System.Boolean)this.CurrentRow["FinishedGoodsFlag"];
            }
            set
            {
                this.CurrentRow["FinishedGoodsFlag"] = value;
            }
        }

        /// <summary>
        /// Color
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Color"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Color
        {
            get
            {
                return (System.String)this.CurrentRow["Color"];
            }
            set
            {
                this.CurrentRow["Color"] = value;
            }
        }

        /// <summary>
        /// SafetyStockLevel
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("SafetyStockLevel"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int16 SafetyStockLevel
        {
            get
            {
                return (System.Int16)this.CurrentRow["SafetyStockLevel"];
            }
            set
            {
                this.CurrentRow["SafetyStockLevel"] = value;
            }
        }

        /// <summary>
        /// ReorderPoint
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ReorderPoint"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int16 ReorderPoint
        {
            get
            {
                return (System.Int16)this.CurrentRow["ReorderPoint"];
            }
            set
            {
                this.CurrentRow["ReorderPoint"] = value;
            }
        }

        /// <summary>
        /// StandardCost
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("StandardCost"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Decimal StandardCost
        {
            get
            {
                return (System.Decimal)this.CurrentRow["StandardCost"];
            }
            set
            {
                this.CurrentRow["StandardCost"] = value;
            }
        }

        /// <summary>
        /// ListPrice
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ListPrice"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Decimal ListPrice
        {
            get
            {
                return (System.Decimal)this.CurrentRow["ListPrice"];
            }
            set
            {
                this.CurrentRow["ListPrice"] = value;
            }
        }

        /// <summary>
        /// Size
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Size"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Size
        {
            get
            {
                return (System.String)this.CurrentRow["Size"];
            }
            set
            {
                this.CurrentRow["Size"] = value;
            }
        }

        /// <summary>
        /// SizeUnitMeasureCode
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("SizeUnitMeasureCode"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String SizeUnitMeasureCode
        {
            get
            {
                return (System.String)this.CurrentRow["SizeUnitMeasureCode"];
            }
            set
            {
                this.CurrentRow["SizeUnitMeasureCode"] = value;
            }
        }

        /// <summary>
        /// WeightUnitMeasureCode
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("WeightUnitMeasureCode"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String WeightUnitMeasureCode
        {
            get
            {
                return (System.String)this.CurrentRow["WeightUnitMeasureCode"];
            }
            set
            {
                this.CurrentRow["WeightUnitMeasureCode"] = value;
            }
        }

        /// <summary>
        /// Weight
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Weight"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Decimal Weight
        {
            get
            {
                return (System.Decimal)this.CurrentRow["Weight"];
            }
            set
            {
                this.CurrentRow["Weight"] = value;
            }
        }

        /// <summary>
        /// DaysToManufacture
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("DaysToManufacture"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 DaysToManufacture
        {
            get
            {
                return (System.Int32)this.CurrentRow["DaysToManufacture"];
            }
            set
            {
                this.CurrentRow["DaysToManufacture"] = value;
            }
        }

        /// <summary>
        /// ProductLine
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ProductLine"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String ProductLine
        {
            get
            {
                return (System.String)this.CurrentRow["ProductLine"];
            }
            set
            {
                this.CurrentRow["ProductLine"] = value;
            }
        }

        /// <summary>
        /// Class
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Class"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Class
        {
            get
            {
                return (System.String)this.CurrentRow["Class"];
            }
            set
            {
                this.CurrentRow["Class"] = value;
            }
        }

        /// <summary>
        /// Style
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Style"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Style
        {
            get
            {
                return (System.String)this.CurrentRow["Style"];
            }
            set
            {
                this.CurrentRow["Style"] = value;
            }
        }

        /// <summary>
        /// ProductSubcategoryID
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ProductSubcategoryID"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 ProductSubcategoryID
        {
            get
            {
                return (System.Int32)this.CurrentRow["ProductSubcategoryID"];
            }
            set
            {
                this.CurrentRow["ProductSubcategoryID"] = value;
            }
        }

        /// <summary>
        /// ProductModelID
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ProductModelID"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 ProductModelID
        {
            get
            {
                return (System.Int32)this.CurrentRow["ProductModelID"];
            }
            set
            {
                this.CurrentRow["ProductModelID"] = value;
            }
        }

        /// <summary>
        /// SellStartDate
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("SellStartDate"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime SellStartDate
        {
            get
            {
                return (System.DateTime)this.CurrentRow["SellStartDate"];
            }
            set
            {
                this.CurrentRow["SellStartDate"] = value;
            }
        }

        /// <summary>
        /// SellEndDate
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("SellEndDate"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime SellEndDate
        {
            get
            {
                return (System.DateTime)this.CurrentRow["SellEndDate"];
            }
            set
            {
                this.CurrentRow["SellEndDate"] = value;
            }
        }

        /// <summary>
        /// DiscontinuedDate
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("DiscontinuedDate"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime DiscontinuedDate
        {
            get
            {
                return (System.DateTime)this.CurrentRow["DiscontinuedDate"];
            }
            set
            {
                this.CurrentRow["DiscontinuedDate"] = value;
            }
        }

        /// <summary>
        /// rowguid
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("rowguid"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Guid rowguid
        {
            get
            {
                return (System.Guid)this.CurrentRow["rowguid"];
            }
            set
            {
                this.CurrentRow["rowguid"] = value;
            }
        }

        /// <summary>
        /// ModifiedDate
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ModifiedDate"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime ModifiedDate
        {
            get
            {
                return (System.DateTime)this.CurrentRow["ModifiedDate"];
            }
            set
            {
                this.CurrentRow["ModifiedDate"] = value;
            }
        }

        #endregion

        #region Field Property Events

        #endregion

        #region Nested Types & Field Security

        /// <summary>
        /// Contains all of the field names that belong to the business object.
        /// </summary>
        public enum ProductBOFieldNames
        {
            ProductID,
            Name,
            ProductNumber,
            MakeFlag,
            FinishedGoodsFlag,
            Color,
            SafetyStockLevel,
            ReorderPoint,
            StandardCost,
            ListPrice,
            Size,
            SizeUnitMeasureCode,
            WeightUnitMeasureCode,
            Weight,
            DaysToManufacture,
            ProductLine,
            Class,
            Style,
            ProductSubcategoryID,
            ProductModelID,
            SellStartDate,
            SellEndDate,
            DiscontinuedDate,
            rowguid,
            ModifiedDate,
            CUSTOM_FIELD
        }

        /// <summary>
        /// Gets the System.Type of the enumeration that contains the field names for the business object.
        /// </summary>
        public override System.Type GetFieldEnumType()
        {
            return typeof(ProductBOFieldNames);
        }

        /// <summary>
        /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
        /// </summary>
        protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs(System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm)
        {
            return new CheckFieldSecurityEventArgs<ProductBOFieldNames>(Field, CustomField, PermissionKey, Perm);
        }

        /// <summary>
        /// Describes a method that will handle the CheckFieldScurity event.
        /// </summary>
        public delegate void CheckFieldSecurityEventHandler(object sender, CheckFieldSecurityEventArgs<ProductBOFieldNames> e);

        /// <summary>
        /// Occurs when the business objects needs to check the security on a field.
        /// </summary>
        public event CheckFieldSecurityEventHandler CheckFieldSecurity;

        /// <summary>
        /// Raises the CheckFieldSecurity event.
        /// </summary>
        protected override void OnCheckFieldSecurity(CheckFieldSecurityEventArgsBase e)
        {
            if (this.CheckFieldSecurity != null)
            {
                this.CheckFieldSecurity(this, (CheckFieldSecurityEventArgs<ProductBOFieldNames>)e);
            }
        }

        #endregion

        #region Item Property Implementation


        private static List<string> _AllFieldsList;
        private static Dictionary<string, DbType> _FieldDbTypes;
        private static BusinessLayerFieldEnumDictionary _FieldEnums;
        private static Dictionary<string, int> _FieldLengths;
        private static Dictionary<string, int> _FieldNativeDbTypes;
        private static Dictionary<string, string> _FieldPermissionKeys;

        /// <summary>
        /// Initializes the static members of the ProductBO class.
        /// </summary>
        static ProductBO()
        {
            //-- Create the new shared dictionary and populate it with an 
            //   instance of each property descriptor
            _PropertyDescriptors = new PropertyDescriptorDictionary(30);
            _PropertyDescriptors.Add("ProductID", new FieldDescriptor(ProductBOFieldNames.ProductID, typeof(System.Int32)));
            _PropertyDescriptors.Add("Name", new FieldDescriptor(ProductBOFieldNames.Name, typeof(System.String)));
            _PropertyDescriptors.Add("ProductNumber", new FieldDescriptor(ProductBOFieldNames.ProductNumber, typeof(System.String)));
            _PropertyDescriptors.Add("MakeFlag", new FieldDescriptor(ProductBOFieldNames.MakeFlag, typeof(System.Boolean)));
            _PropertyDescriptors.Add("FinishedGoodsFlag", new FieldDescriptor(ProductBOFieldNames.FinishedGoodsFlag, typeof(System.Boolean)));
            _PropertyDescriptors.Add("Color", new FieldDescriptor(ProductBOFieldNames.Color, typeof(System.String)));
            _PropertyDescriptors.Add("SafetyStockLevel", new FieldDescriptor(ProductBOFieldNames.SafetyStockLevel, typeof(System.Int16)));
            _PropertyDescriptors.Add("ReorderPoint", new FieldDescriptor(ProductBOFieldNames.ReorderPoint, typeof(System.Int16)));
            _PropertyDescriptors.Add("StandardCost", new FieldDescriptor(ProductBOFieldNames.StandardCost, typeof(System.Decimal)));
            _PropertyDescriptors.Add("ListPrice", new FieldDescriptor(ProductBOFieldNames.ListPrice, typeof(System.Decimal)));
            _PropertyDescriptors.Add("Size", new FieldDescriptor(ProductBOFieldNames.Size, typeof(System.String)));
            _PropertyDescriptors.Add("SizeUnitMeasureCode", new FieldDescriptor(ProductBOFieldNames.SizeUnitMeasureCode, typeof(System.String)));
            _PropertyDescriptors.Add("WeightUnitMeasureCode", new FieldDescriptor(ProductBOFieldNames.WeightUnitMeasureCode, typeof(System.String)));
            _PropertyDescriptors.Add("Weight", new FieldDescriptor(ProductBOFieldNames.Weight, typeof(System.Decimal)));
            _PropertyDescriptors.Add("DaysToManufacture", new FieldDescriptor(ProductBOFieldNames.DaysToManufacture, typeof(System.Int32)));
            _PropertyDescriptors.Add("ProductLine", new FieldDescriptor(ProductBOFieldNames.ProductLine, typeof(System.String)));
            _PropertyDescriptors.Add("Class", new FieldDescriptor(ProductBOFieldNames.Class, typeof(System.String)));
            _PropertyDescriptors.Add("Style", new FieldDescriptor(ProductBOFieldNames.Style, typeof(System.String)));
            _PropertyDescriptors.Add("ProductSubcategoryID", new FieldDescriptor(ProductBOFieldNames.ProductSubcategoryID, typeof(System.Int32)));
            _PropertyDescriptors.Add("ProductModelID", new FieldDescriptor(ProductBOFieldNames.ProductModelID, typeof(System.Int32)));
            _PropertyDescriptors.Add("SellStartDate", new FieldDescriptor(ProductBOFieldNames.SellStartDate, typeof(System.DateTime)));
            _PropertyDescriptors.Add("SellEndDate", new FieldDescriptor(ProductBOFieldNames.SellEndDate, typeof(System.DateTime)));
            _PropertyDescriptors.Add("DiscontinuedDate", new FieldDescriptor(ProductBOFieldNames.DiscontinuedDate, typeof(System.DateTime)));
            _PropertyDescriptors.Add("rowguid", new FieldDescriptor(ProductBOFieldNames.rowguid, typeof(System.Guid)));
            _PropertyDescriptors.Add("ModifiedDate", new FieldDescriptor(ProductBOFieldNames.ModifiedDate, typeof(System.DateTime)));

            _AllFieldsList = new List<string>(25);
            _AllFieldsList.Add("ProductID");
            _AllFieldsList.Add("Name");
            _AllFieldsList.Add("ProductNumber");
            _AllFieldsList.Add("MakeFlag");
            _AllFieldsList.Add("FinishedGoodsFlag");
            _AllFieldsList.Add("Color");
            _AllFieldsList.Add("SafetyStockLevel");
            _AllFieldsList.Add("ReorderPoint");
            _AllFieldsList.Add("StandardCost");
            _AllFieldsList.Add("ListPrice");
            _AllFieldsList.Add("Size");
            _AllFieldsList.Add("SizeUnitMeasureCode");
            _AllFieldsList.Add("WeightUnitMeasureCode");
            _AllFieldsList.Add("Weight");
            _AllFieldsList.Add("DaysToManufacture");
            _AllFieldsList.Add("ProductLine");
            _AllFieldsList.Add("Class");
            _AllFieldsList.Add("Style");
            _AllFieldsList.Add("ProductSubcategoryID");
            _AllFieldsList.Add("ProductModelID");
            _AllFieldsList.Add("SellStartDate");
            _AllFieldsList.Add("SellEndDate");
            _AllFieldsList.Add("DiscontinuedDate");
            _AllFieldsList.Add("rowguid");
            _AllFieldsList.Add("ModifiedDate");

            _FieldDbTypes = new Dictionary<string, DbType>(25);
            _FieldDbTypes.Add("ProductID", DbType.Int32);
            _FieldDbTypes.Add("Name", DbType.String);
            _FieldDbTypes.Add("ProductNumber", DbType.String);
            _FieldDbTypes.Add("MakeFlag", DbType.Boolean);
            _FieldDbTypes.Add("FinishedGoodsFlag", DbType.Boolean);
            _FieldDbTypes.Add("Color", DbType.String);
            _FieldDbTypes.Add("SafetyStockLevel", DbType.Int16);
            _FieldDbTypes.Add("ReorderPoint", DbType.Int16);
            _FieldDbTypes.Add("StandardCost", DbType.Currency);
            _FieldDbTypes.Add("ListPrice", DbType.Currency);
            _FieldDbTypes.Add("Size", DbType.String);
            _FieldDbTypes.Add("SizeUnitMeasureCode", DbType.StringFixedLength);
            _FieldDbTypes.Add("WeightUnitMeasureCode", DbType.StringFixedLength);
            _FieldDbTypes.Add("Weight", DbType.Decimal);
            _FieldDbTypes.Add("DaysToManufacture", DbType.Int32);
            _FieldDbTypes.Add("ProductLine", DbType.StringFixedLength);
            _FieldDbTypes.Add("Class", DbType.StringFixedLength);
            _FieldDbTypes.Add("Style", DbType.StringFixedLength);
            _FieldDbTypes.Add("ProductSubcategoryID", DbType.Int32);
            _FieldDbTypes.Add("ProductModelID", DbType.Int32);
            _FieldDbTypes.Add("SellStartDate", DbType.DateTime);
            _FieldDbTypes.Add("SellEndDate", DbType.DateTime);
            _FieldDbTypes.Add("DiscontinuedDate", DbType.DateTime);
            _FieldDbTypes.Add("rowguid", DbType.Guid);
            _FieldDbTypes.Add("ModifiedDate", DbType.DateTime);

            _FieldEnums = new BusinessLayerFieldEnumDictionary(26);
            _FieldEnums.Add("ProductID", ProductBOFieldNames.ProductID);
            _FieldEnums.Add("Name", ProductBOFieldNames.Name);
            _FieldEnums.Add("ProductNumber", ProductBOFieldNames.ProductNumber);
            _FieldEnums.Add("MakeFlag", ProductBOFieldNames.MakeFlag);
            _FieldEnums.Add("FinishedGoodsFlag", ProductBOFieldNames.FinishedGoodsFlag);
            _FieldEnums.Add("Color", ProductBOFieldNames.Color);
            _FieldEnums.Add("SafetyStockLevel", ProductBOFieldNames.SafetyStockLevel);
            _FieldEnums.Add("ReorderPoint", ProductBOFieldNames.ReorderPoint);
            _FieldEnums.Add("StandardCost", ProductBOFieldNames.StandardCost);
            _FieldEnums.Add("ListPrice", ProductBOFieldNames.ListPrice);
            _FieldEnums.Add("Size", ProductBOFieldNames.Size);
            _FieldEnums.Add("SizeUnitMeasureCode", ProductBOFieldNames.SizeUnitMeasureCode);
            _FieldEnums.Add("WeightUnitMeasureCode", ProductBOFieldNames.WeightUnitMeasureCode);
            _FieldEnums.Add("Weight", ProductBOFieldNames.Weight);
            _FieldEnums.Add("DaysToManufacture", ProductBOFieldNames.DaysToManufacture);
            _FieldEnums.Add("ProductLine", ProductBOFieldNames.ProductLine);
            _FieldEnums.Add("Class", ProductBOFieldNames.Class);
            _FieldEnums.Add("Style", ProductBOFieldNames.Style);
            _FieldEnums.Add("ProductSubcategoryID", ProductBOFieldNames.ProductSubcategoryID);
            _FieldEnums.Add("ProductModelID", ProductBOFieldNames.ProductModelID);
            _FieldEnums.Add("SellStartDate", ProductBOFieldNames.SellStartDate);
            _FieldEnums.Add("SellEndDate", ProductBOFieldNames.SellEndDate);
            _FieldEnums.Add("DiscontinuedDate", ProductBOFieldNames.DiscontinuedDate);
            _FieldEnums.Add("rowguid", ProductBOFieldNames.rowguid);
            _FieldEnums.Add("ModifiedDate", ProductBOFieldNames.ModifiedDate);
            _FieldEnums.Add("CUSTOM_FIELD", ProductBOFieldNames.CUSTOM_FIELD);

            _FieldLengths = new Dictionary<string, int>(25);
            _FieldLengths.Add("ProductID", 0);
            _FieldLengths.Add("Name", 50);
            _FieldLengths.Add("ProductNumber", 25);
            _FieldLengths.Add("MakeFlag", 0);
            _FieldLengths.Add("FinishedGoodsFlag", 0);
            _FieldLengths.Add("Color", 15);
            _FieldLengths.Add("SafetyStockLevel", 0);
            _FieldLengths.Add("ReorderPoint", 0);
            _FieldLengths.Add("StandardCost", 0);
            _FieldLengths.Add("ListPrice", 0);
            _FieldLengths.Add("Size", 5);
            _FieldLengths.Add("SizeUnitMeasureCode", 3);
            _FieldLengths.Add("WeightUnitMeasureCode", 3);
            _FieldLengths.Add("Weight", 0);
            _FieldLengths.Add("DaysToManufacture", 0);
            _FieldLengths.Add("ProductLine", 2);
            _FieldLengths.Add("Class", 2);
            _FieldLengths.Add("Style", 2);
            _FieldLengths.Add("ProductSubcategoryID", 0);
            _FieldLengths.Add("ProductModelID", 0);
            _FieldLengths.Add("SellStartDate", 0);
            _FieldLengths.Add("SellEndDate", 0);
            _FieldLengths.Add("DiscontinuedDate", 0);
            _FieldLengths.Add("rowguid", 0);
            _FieldLengths.Add("ModifiedDate", 0);

            _FieldNativeDbTypes = new Dictionary<string, int>(25);
            _FieldNativeDbTypes.Add("ProductID", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("Name", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("ProductNumber", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("MakeFlag", (int)System.Data.SqlDbType.Bit);
            _FieldNativeDbTypes.Add("FinishedGoodsFlag", (int)System.Data.SqlDbType.Bit);
            _FieldNativeDbTypes.Add("Color", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("SafetyStockLevel", (int)System.Data.SqlDbType.SmallInt);
            _FieldNativeDbTypes.Add("ReorderPoint", (int)System.Data.SqlDbType.SmallInt);
            _FieldNativeDbTypes.Add("StandardCost", (int)System.Data.SqlDbType.Money);
            _FieldNativeDbTypes.Add("ListPrice", (int)System.Data.SqlDbType.Money);
            _FieldNativeDbTypes.Add("Size", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("SizeUnitMeasureCode", (int)System.Data.SqlDbType.NChar);
            _FieldNativeDbTypes.Add("WeightUnitMeasureCode", (int)System.Data.SqlDbType.NChar);
            _FieldNativeDbTypes.Add("Weight", (int)System.Data.SqlDbType.Decimal);
            _FieldNativeDbTypes.Add("DaysToManufacture", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("ProductLine", (int)System.Data.SqlDbType.NChar);
            _FieldNativeDbTypes.Add("Class", (int)System.Data.SqlDbType.NChar);
            _FieldNativeDbTypes.Add("Style", (int)System.Data.SqlDbType.NChar);
            _FieldNativeDbTypes.Add("ProductSubcategoryID", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("ProductModelID", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("SellStartDate", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("SellEndDate", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("DiscontinuedDate", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("rowguid", (int)System.Data.SqlDbType.UniqueIdentifier);
            _FieldNativeDbTypes.Add("ModifiedDate", (int)System.Data.SqlDbType.DateTime);

            _FieldPermissionKeys = new Dictionary<string, string>(25);

        }

        private static bool _AreCustomDescriptorsEvaluated = false;
        protected override bool AreCustomDescriptorsEvaluated
        {
            get
            {
                bool llReturn = _AreCustomDescriptorsEvaluated;
                _AreCustomDescriptorsEvaluated = true;
                return llReturn;
            }
        }

        private static PropertyDescriptorDictionary _PropertyDescriptors;
        protected override PropertyDescriptorDictionary PropertyDescriptors
        {
            get
            {
                return _PropertyDescriptors;
            }
        }

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of fields within the ProductBO business object.
        /// </summary>
        private class FieldDescriptor :
        MicroFour.StrataFrame.Business.FieldPropertyDescriptor<ProductBOFieldNames>
        {
            public FieldDescriptor(ProductBOFieldNames field, Type fieldType) :
                base(field, fieldType) { }
            private static Type _ComponentType = typeof(ProductBO);
            public override object GetValue(object component)
            {
                switch (this.Field)
                {
                    case ProductBOFieldNames.ProductID:
                        return ((ProductBO)component).ProductID;
                    case ProductBOFieldNames.Name:
                        return ((ProductBO)component).Name;
                    case ProductBOFieldNames.ProductNumber:
                        return ((ProductBO)component).ProductNumber;
                    case ProductBOFieldNames.MakeFlag:
                        return ((ProductBO)component).MakeFlag;
                    case ProductBOFieldNames.FinishedGoodsFlag:
                        return ((ProductBO)component).FinishedGoodsFlag;
                    case ProductBOFieldNames.Color:
                        return ((ProductBO)component).Color;
                    case ProductBOFieldNames.SafetyStockLevel:
                        return ((ProductBO)component).SafetyStockLevel;
                    case ProductBOFieldNames.ReorderPoint:
                        return ((ProductBO)component).ReorderPoint;
                    case ProductBOFieldNames.StandardCost:
                        return ((ProductBO)component).StandardCost;
                    case ProductBOFieldNames.ListPrice:
                        return ((ProductBO)component).ListPrice;
                    case ProductBOFieldNames.Size:
                        return ((ProductBO)component).Size;
                    case ProductBOFieldNames.SizeUnitMeasureCode:
                        return ((ProductBO)component).SizeUnitMeasureCode;
                    case ProductBOFieldNames.WeightUnitMeasureCode:
                        return ((ProductBO)component).WeightUnitMeasureCode;
                    case ProductBOFieldNames.Weight:
                        return ((ProductBO)component).Weight;
                    case ProductBOFieldNames.DaysToManufacture:
                        return ((ProductBO)component).DaysToManufacture;
                    case ProductBOFieldNames.ProductLine:
                        return ((ProductBO)component).ProductLine;
                    case ProductBOFieldNames.Class:
                        return ((ProductBO)component).Class;
                    case ProductBOFieldNames.Style:
                        return ((ProductBO)component).Style;
                    case ProductBOFieldNames.ProductSubcategoryID:
                        return ((ProductBO)component).ProductSubcategoryID;
                    case ProductBOFieldNames.ProductModelID:
                        return ((ProductBO)component).ProductModelID;
                    case ProductBOFieldNames.SellStartDate:
                        return ((ProductBO)component).SellStartDate;
                    case ProductBOFieldNames.SellEndDate:
                        return ((ProductBO)component).SellEndDate;
                    case ProductBOFieldNames.DiscontinuedDate:
                        return ((ProductBO)component).DiscontinuedDate;
                    case ProductBOFieldNames.rowguid:
                        return ((ProductBO)component).rowguid;
                    case ProductBOFieldNames.ModifiedDate:
                        return ((ProductBO)component).ModifiedDate;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override void SetValue(object component, object value)
            {
                switch (this.Field)
                {
                    case ProductBOFieldNames.ProductID:
                        ((ProductBO)component).ProductID = (System.Int32)value;
                        break;
                    case ProductBOFieldNames.Name:
                        ((ProductBO)component).Name = (System.String)value;
                        break;
                    case ProductBOFieldNames.ProductNumber:
                        ((ProductBO)component).ProductNumber = (System.String)value;
                        break;
                    case ProductBOFieldNames.MakeFlag:
                        ((ProductBO)component).MakeFlag = (System.Boolean)value;
                        break;
                    case ProductBOFieldNames.FinishedGoodsFlag:
                        ((ProductBO)component).FinishedGoodsFlag = (System.Boolean)value;
                        break;
                    case ProductBOFieldNames.Color:
                        ((ProductBO)component).Color = (System.String)value;
                        break;
                    case ProductBOFieldNames.SafetyStockLevel:
                        ((ProductBO)component).SafetyStockLevel = (System.Int16)value;
                        break;
                    case ProductBOFieldNames.ReorderPoint:
                        ((ProductBO)component).ReorderPoint = (System.Int16)value;
                        break;
                    case ProductBOFieldNames.StandardCost:
                        ((ProductBO)component).StandardCost = (System.Decimal)value;
                        break;
                    case ProductBOFieldNames.ListPrice:
                        ((ProductBO)component).ListPrice = (System.Decimal)value;
                        break;
                    case ProductBOFieldNames.Size:
                        ((ProductBO)component).Size = (System.String)value;
                        break;
                    case ProductBOFieldNames.SizeUnitMeasureCode:
                        ((ProductBO)component).SizeUnitMeasureCode = (System.String)value;
                        break;
                    case ProductBOFieldNames.WeightUnitMeasureCode:
                        ((ProductBO)component).WeightUnitMeasureCode = (System.String)value;
                        break;
                    case ProductBOFieldNames.Weight:
                        ((ProductBO)component).Weight = (System.Decimal)value;
                        break;
                    case ProductBOFieldNames.DaysToManufacture:
                        ((ProductBO)component).DaysToManufacture = (System.Int32)value;
                        break;
                    case ProductBOFieldNames.ProductLine:
                        ((ProductBO)component).ProductLine = (System.String)value;
                        break;
                    case ProductBOFieldNames.Class:
                        ((ProductBO)component).Class = (System.String)value;
                        break;
                    case ProductBOFieldNames.Style:
                        ((ProductBO)component).Style = (System.String)value;
                        break;
                    case ProductBOFieldNames.ProductSubcategoryID:
                        ((ProductBO)component).ProductSubcategoryID = (System.Int32)value;
                        break;
                    case ProductBOFieldNames.ProductModelID:
                        ((ProductBO)component).ProductModelID = (System.Int32)value;
                        break;
                    case ProductBOFieldNames.SellStartDate:
                        ((ProductBO)component).SellStartDate = (System.DateTime)value;
                        break;
                    case ProductBOFieldNames.SellEndDate:
                        ((ProductBO)component).SellEndDate = (System.DateTime)value;
                        break;
                    case ProductBOFieldNames.DiscontinuedDate:
                        ((ProductBO)component).DiscontinuedDate = (System.DateTime)value;
                        break;
                    case ProductBOFieldNames.rowguid:
                        ((ProductBO)component).rowguid = (System.Guid)value;
                        break;
                    case ProductBOFieldNames.ModifiedDate:
                        ((ProductBO)component).ModifiedDate = (System.DateTime)value;
                        break;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        #endregion

    }

}
